function var_f = var_following(M,names)
% variance of wages directly after jtj transition and later

spel_length = 12; %minimum spell length
period_begin = 10; %length of initial period

M(:,31) = count_obs(M(:,30));
names{1,31} = 'spell length';
M(M(:,31)<spel_length,:) = []; %drop short spells
fcn = @(x){cumsum(x)}; 
M(:,32) = accumarray_expand(ones(length(M(:,30)),1),M(:,30),fcn);
names{1,32} = 'number of obs in spell';
fcn = @(x)max(x);
M(:,33) = accumarray_expand(M(:,26),M(:,30),fcn);
M(M(:,33)==0,:) = []; %keep only spells resulting from jtj movement
M(:,33) = [];
M(M(:,26)==1,:) = []; %drop initial wage change
M(:,33) = M(:,32)<=period_begin;
var_f.early = var(M(M(:,33)==1,29));
var_f.late = var(M(M(:,33)==0,29));


end