function [grid] = Norm(N, mue, sigma)
%discretize normal distribution into equi-likely bins

grid_probs=linspace(0,1,N+1);   % generate equi-likely bins
bounds=norminv(grid_probs);     % corresponding bin bounds
        
% Calculate grid - centers
grid = N*( normpdf(bounds(1:end-1)) - normpdf(bounds(2:end)) );



grid=grid*sigma + mue;