function error = con_error(x,n,sigma,coef)

%compute MA vector

shock = sigma*randn(n+12,1);

correct = zeros(n,1);
for i = 1:n %compute correction vector
    correct(i,1) = coef*shock(i:i+12,1);
end
error = x+correct;

end