function yi = interp1_l(x,y,xi)

%linear interpolation

h = diff(x);

% Interpolate

%yi = zeros(ni,1);
ni = length(xi);
p = 1:ni;
ny = length(y);
% Find indices of subintervals, x(k) <= u < x(k+1),
% or u < x(1) or u >= x(m-1).

[~,k] = histc(xi,x);
k(xi<x(1)) = 1;
k(xi>=x(ny)) = ny-1;
s = (xi - x(k))./h(k);

yi(p,1) = y(k,1) + s.*(y(k+1,1)-y(k,1));

%varargout{1} = yi;
  

end 