function [PI, step] = transitions(N,sigma,grid)
%discreizes a standard normal distribution with SE sigma on the grid(grid)
%with N points and returns probability to be at any discretized point and
%number of grid points on grid between two bin centers

step=floor((6*sigma/(N-1))/max(diff(grid))); %number of grid points between two bin centers
step2 = step*max(diff(grid));
grid_eval = (-(N-1)/2)*step2:step2:((N-1)/2)*step2;
PI = equi(grid_eval,step2,sigma); 


end