local i=1
cd "$rootdir/rawdata"
use $ids ssuseq ssuid spanel rhcalmn rhcalyr rot eentaid eppintvw epppnum shhadid whfnwgt wffinwgt wsfinwgt wpfinwgt gvarstr tage using sipp96l`i'.dta, clear
sort $ids
cd "$rootdir/tmp"
save test, replace

* gen unique state id to merge
local i = `i'+1
while `i'>1 & `i'<13 {
cd "$rootdir/rawdata"
use $ids ssuseq ssuid spanel rhcalmn rhcalyr rot eentaid eppintvw epppnum shhadid whfnwgt wffinwgt wsfinwgt wpfinwgt gvarstr tage using sipp96l`i'.dta, clear
sort $ids
cd "$rootdir/tmp"
append using test
save test, replace

local i=`i'+1
} 
rename tage age
* gen unique state id to merge
sort ssuid epppnum
egen idst = concat(ssuid epppnum)
sort idst wave srefmon
save test, replace

*make names consistent
rename rhcalyr year
notes year: SIPP: rhcalyr (96,01,04)
rename rhcalmn month
notes month: SIPP: rhcalmn (96,01,04)
rename spanel panel
notes panel: SIPP: spanel (96,01,04)
gen pp_mis = 1
notes pp_mis: only required in 1993 panel

sum
keep id idst srefmon wave age month year panel pp_mis rot wpfinwgt

sort idst year month
label data "Set A: ID and Weights,  SIPP1996"

cd "$rootdir/output"
save "/Uni/Het Agents/Daten/SIPP/1996 CEPR/output/set_a.dta", replace
clear

