local i=1
cd "$rootdir/rawdata"
use $ids ssuid epppnum rot spanel rhcalyr rhcalmn tage ejobcntr rmesr rmwkwjb rwksperm eclwrk* eunion* ecntrc1 ecntrc2 epayhr* ejbhrs* tpmsum* tpyrate* ejbind* tjbocc* tempall* tempsiz* eeno* estlemp* tsjdate* tejdate* ersend* apmsum* apyrate* eafnow tbmsum* tmlmsum abmsum* rwkesr1 rwkesr2 rwkesr3 rwkesr4 rwkesr5 using sipp96l`i'.dta, clear
sort $ids
cd "$rootdir/tmp"
save test, replace
local i = `i'+1
while `i'>1 & `i'<13 {
cd "$rootdir/rawdata"
use $ids ssuid epppnum rot spanel rhcalyr rhcalmn tage ejobcntr rmesr rmwkwjb rwksperm eclwrk* eunion* ecntrc1 ecntrc2 epayhr* ejbhrs* tpmsum* tpyrate* ejbind* tjbocc* tempall* tempsiz* eeno* estlemp* tsjdate* tejdate* ersend* apmsum* apyrate* eafnow tbmsum* tmlmsum abmsum* rwkesr1 rwkesr2 rwkesr3 rwkesr4 rwkesr5 using sipp96l`i'.dta, clear
sort $ids
cd "$rootdir/tmp"
append using test
sort $ids
save test, replace
local i=`i'+1
}        
sort id rot
save test, replace

cd "$rootdir/rawdata"
use id rot tmakmnyr eyrsinc2 using sipp96t1, clear
cd "$rootdir/tmp" 
sort id rot
merge id rot using test
tab _merge
drop if _merge==1
drop _merge

* give uniform names, as necessary
rename rmesr esr
rename rwksperm wksper
renpfix ejbhrs hours
renpfix tpyrate rate
renpfix tpmsum earn
renpfix ejbind ind3
renpfix tjbocc occ3
renpfix eclwrk class
renpfix eunion union
renpfix eeno job
renpfix epayhr hrly
renpfix tbmsum selfinc
rename tmlmsum mooninc
rename tage age
rename rhcalyr year
rename rhcalmn month

rename tmakmnyr labor_e_p
rename eyrsinc2 labor_nw
cd "$rootdir/tmp"
sort $ids
save test, replace


label var ejobcntr "No. of jobs this month (0=contingent worker)"
rename ejobcntr njobs

local i = 1
while `i'<=2 {
tostring tsjdate1, format(%11.0f) gen(sdate`i')
gen str4 s`i'year_ = substr(sdate`i',1,4)
gen str2 s`i'month_ = substr(sdate`i',5,6)
gen str2 s`i'day_ = substr(sdate`i',7,8)
gen syear`i' = real(s`i'year_)
gen smonth`i' = real(s`i'month_)
gen sday`i' = real(s`i'day_)
drop sdate`i' s`i'year_ s`i'month_ s`i'day_

tostring tejdate`i', format(%11.0f) gen(edate`i')
tostring edate`i', format(%11.0f) replace
gen str4 e`i'year_ = substr(edate`i',1,4)
gen str2 e`i'month_ = substr(edate`i',5,6)
gen str2 e`i'day_ = substr(edate`i',7,8)
gen eyear`i' = real(e`i'year_)
gen emonth`i' = real(e`i'month_)
gen eday`i' = real(e`i'day_)
drop edate`i' e`i'year_ e`i'month_ e`i'day_ 

recode smonth`i' 0=.
recode emonth`i' 0=.
recode eday`i' 0=.
local i = `i'+1
}
drop tsjdate* tejdate*


cd "$rootdir/tmp"
sort $ids
save test, replace


*clean date job started
egen job_id1 = group(id job1)
sort job_id1 year month
by job_id1: replace syear1 = syear1[1]
by job_id1: replace smonth1 = smonth1[1]
by job_id1: replace sday1 = sday1[1]
by job_id1: replace smonth1 = month[1] if smonth1==. & syear1>0
gen index = 0
replace index = 1 if syear1>year
by job_id1: egen index2 = max(index)
by job_id1: replace syear1=year[1] if index2==1
drop index index2
gen index= 0
replace index = (year-syear1)*12+month-smonth1 if syear1>0 & smonth1>0
by job_id1: replace index = index[1]
by job_id1: replace smonth1 = month[1] if index<0
drop index job_id1

egen job_id2 = group(id job2)
sort job_id2 year month
by job_id2: replace syear2 = syear2[1]
by job_id2: replace smonth2 = smonth2[1]
by job_id2: replace sday2 = sday2[1]
by job_id2: replace smonth2 = month[1] if smonth2==. & syear2>0
gen index = 0
replace index = 1 if syear2>year
by job_id2: egen index2 = max(index)
by job_id2: replace syear2=year[1] if index2==1
drop index index2
gen index= 0
replace index = (year-syear2)*12+month-smonth2 if syear2>0 & smonth2>0
by job_id2: replace index = index[1]
by job_id2: replace smonth2 = month[1] if index<0
drop index job_id2


* relable
sort id year month
label define impute 0 "Not imputed" 1 "Statistical imputation(hot deck)" 2 "Cold deck imputation" 3 "Logical imputation(derivation)" 4 "Statistical or logical imputation using previous wave data"
local i = 1
while `i'<3 {
recode estlemp`i' 0=.
recode estlemp`i' 2=0
label var ersend`i' "Reason stopped working"
label define ersend`i' 1 "On layoff" 2 "Retirement or old age" 3 "Childcare problems" 4 "Other family/personal obligations" 5 "Own illness" 6 "Own injury" 7 "School/training" 8 "Discharged/fired" 9 "Employer bankrupt" 10 "Employer sold business" 11 "Job was temporary and ended" 12 "Quit to take another job" 13 "Slack work or business conditions" 14 "Unsatisfactory work arrangements (hours, pay, etc)" 15 "Quit for some other reason"
notes ersend`i': For 92/93: 1 "Laid off" 2 "Retired" 8 "Discharged" 11 "Job was temporary and ended" 12 "Quit to take another job" 15 "Quit for some other reason"

gen occ14_`i' = 1 if occ3`i'>=003 & occ3`i'<=37 & occ3`i'~=.
replace occ14_`i' = 2 if occ3`i'>=43 & occ3`i'<=199 & occ3`i'~=.
replace occ14_`i' = 3 if occ3`i'>=203 & occ3`i'<=235 & occ3`i'~=.
replace occ14_`i' = 4 if occ3`i'>=243 & occ3`i'<=285 & occ3`i'~=.
replace occ14_`i' = 5 if occ3`i'>=303 & occ3`i'<=389 & occ3`i'~=.
replace occ14_`i' = 6 if occ3`i'>=403 & occ3`i'<=407 & occ3`i'~=.
replace occ14_`i' = 7 if occ3`i'>=413 & occ3`i'<=427 & occ3`i'~=.
replace occ14_`i' = 8 if occ3`i'>=433 & occ3`i'<=469 & occ3`i'~=.
replace occ14_`i' = 9 if occ3`i'>=473 & occ3`i'<=499 & occ3`i'~=.
replace occ14_`i' = 10 if occ3`i'>=503 & occ3`i'<=699 & occ3`i'~=.
replace occ14_`i' = 11 if occ3`i'>=703 & occ3`i'<=799 & occ3`i'~=.
replace occ14_`i' = 12 if occ3`i'>=803 & occ3`i'<=859 & occ3`i'~=.
replace occ14_`i' = 13 if occ3`i'>=864 & occ3`i'<=889 & occ3`i'~=.
replace occ14_`i' = 14 if occ3`i'>=905 & occ3`i'~=.
label var occ14_`i' "Occupation, Major Groups"
label define occ14_`i' 1 "Executive, Administrative, and Managerial" 2 "Professional Specialty" 3 "Technicians and Related Support" 4 "Sales" 5 "Administrative Support , Including Clerical" 6 "Private Household Services" 7 "Protective Services" 8 "Services, except Household and Protective" 9 "Farming, Forestry, and Fishing" 10 "Precision Production, Craft, and Repair" 11 "Machine Operators, Assemblers, and Inspectors" 12 "Transportation and Material Moving" 13 "Handlers, Equipment Cleaners, Helpers, and Laborers" 14 "Armed Forces" 
label values occ14_`i' occ14_`i'


generate ind23_`i' = 1 if ind3`i'>=10 & ind3`i'<=31 & ind3`i'~=.
replace ind23_`i' = 21 if ind3`i'>=31 & ind3`i'<=32 & ind3`i'~=.
replace ind23_`i' = 2 if ind3`i'>=40 & ind3`i'<=50 & ind3`i'~=.
replace ind23_`i' = 3 if ind3`i'==60 & ind3`i'~=.
replace ind23_`i' = 5 if ind3`i'>=100 & ind3`i'<=222 & ind3`i'~=.
replace ind23_`i' = 4 if ind3`i'>=230 & ind3`i'<=392 & ind3`i'~=.
replace ind23_`i' = 6 if ind3`i'>=400 & ind3`i'<=432 & ind3`i'~=.
replace ind23_`i' = 7 if ind3`i'>=440 & ind3`i'<=442 & ind3`i'~=.
replace ind23_`i' = 8 if ind3`i'>=450 & ind3`i'<=472 & ind3`i'~=.
replace ind23_`i' = 9 if ind3`i'>=500 & ind3`i'<=571 & ind3`i'~=.
replace ind23_`i' = 10 if ind3`i'>=580 & ind3`i'<=691 & ind3`i'~=.
replace ind23_`i' = 11 if ind3`i'>=700 & ind3`i'<=712 & ind3`i'~=.
replace ind23_`i' = 12 if ind3`i'==761 & ind3`i'~=.
replace ind23_`i' = 13 if ind3`i'>=721 & ind3`i'<=760 & ind3`i'~=.
replace ind23_`i' = 14 if ind3`i'>=762 & ind3`i'<=791 & ind3`i'~=.
replace ind23_`i' = 15 if ind3`i'>=800 & ind3`i'<=810 & ind3`i'~=.
replace ind23_`i' = 17 if ind3`i'>=812 & ind3`i'<=840 & ind3`i'~=831 & ind3`i'~=.
replace ind23_`i' = 16 if ind3`i'==831 & ind3`i'~=.
replace ind23_`i' = 18 if ind3`i'>=842 & ind3`i'<=860 & ind3`i'~=.
replace ind23_`i' = 19 if ind3`i'>=861 & ind3`i'<=871 & ind3`i'~=.
replace ind23_`i' = 20 if ind3`i'==841 | (ind3`i'>=872 & ind3`i'<=893) & ind3`i'~=.
replace ind23_`i' = 22 if ind3`i'>=900 & ind3`i'<=932 & ind3`i'~=.
replace ind23_`i' = 23 if ind3`i'==991 & ind3`i'~=.

label var ind23_`i' "Industry, Major Groups"
label define ind3`i' 1 "Agriculture" 2 "Mining" 3 "Construction" 4 "Manufacturing: durabales" 5 "Manufacturing: nondurables" 6 "Transportation" 7 "Communications" 8 "Utilities" 9 "Wholesale Trade" 10 "Retail trade" 11 "Finance" 12 "Private Household Services" 13 "Business Services" 14 "Personal Services" 15 "Entertain/Rec. Services" 16 "Hospitals" 17 "Medical Services" 18 "Educational Services" 19 "Social Services" 20 "Other Professional Services" 21 "Forestry" 22 "Public Administration" 23 "Armed Forces"
label values ind23_`i' ind3`i'

recode class`i' 3=13 5=15
recode class`i' 13=5 15=3
	
label define class`i' 1 "Private" 2 "Non-profit" 3 "Federal" 4 "StateGov" 5 "LocalGov" 6 "ArmedFor/Unpaid" 

*add armed forces
replace class`i' = 6 if eafnow==1 & class`i'>0

recode union`i' 2=0
recode union`i' -1=0
label define union`i' 1 "Union" 0 "Non-union"

label values apmsum`i' impute
label values apyrate`i' impute
gen byte earn_imp`i' = apmsum`i'>=1 & apmsum`i'<=4 if earn`i'~=. & earn`i'>0
gen byte wage_imp`i' = apyrate`i'>=1 & apyrate`i'<=4 if rate`i'~=. & rate`i'>0

gen w_imp`i' = 0
replace w_imp`i' = 1 if earn_imp`i'==1 | wage_imp`i'==1
	
replace hrly`i' = 0 if hrly`i'==2
replace hrly`i' = 0 if hrly`i'==-1

recode ecntrc`i' -1=0
recode ecntrc`i' 2=0
	
local i=`i'+1	
}

*recode labor experience
recode labor_e_p -1=0
recode labor_nw -1=0

drop occ31 occ32 ind31 ind32

*recode weeks employed
recode rwkesr1 -1=0
recode rwkesr2 -1=0
recode rwkesr3 -1=0
recode rwkesr4 -1=0
recode rwkesr5 -1=0

*define unemployment/OLF
recode esr -1=8
recode esr .=8
gen emp=0
replace emp= 1 if esr == 1 
replace emp= 1 if esr == 2
replace emp= 0 if esr == 6
replace emp= 0 if esr == 7
replace emp= 0 if esr == 8
*replace emp= 0 if esr == 3
*replace emp= 0 if esr == 4
*replace emp= 0 if esr == 5
replace emp= 1 if esr == 3
replace emp= 1 if esr == 4
replace emp= 1 if esr == 5
replace emp=0 if (earn1==0 | hours1==0) & (earn2==0 | hours2==0)
sort id wave
cd "$rootdir/tmp" 
save test, replace

*generate tenure for later use
gen tenure1_s_y = syear1
gen tenure1_s_m = smonth1
gen tenure1_s_d = sday1
gen tenure2_s_y = syear2
gen tenure2_s_m = smonth2
gen tenure2_s_d = sday2

*clean days employed
gen index=0
replace index = 1 if smonth1==month & smonth1>0 & syear1==year
replace syear1 = 0 if index==0
replace smonth1 = 0 if index==0
replace sday1 = 0 if index == 0
drop index
gen index=0
replace index = 1 if smonth2==month & smonth2>0 & syear2==year
replace syear2 = 0 if index==0
replace smonth2 = 0 if index==0
replace sday2 = 0 if index == 0
drop index
gen index=0
replace index = 1 if emonth1==month & emonth1>0 & eyear1==year
replace eyear1 = 0 if index==0
replace emonth1 = 0 if index==0
replace eday1 = 0 if index == 0
drop index
gen index=0
replace index=1 if sday1>=eday1 & eday1>0
replace eyear1 = 0 if index==1
replace emonth1 = 0 if index==1
replace eday1 = 0 if index==1
drop index
gen index=0
replace index = 1 if emonth2==month & emonth2>0 & eyear2==year
replace eyear2 = 0 if index==0
replace emonth2 = 0 if index==0
replace eday2 = 0 if index == 0
drop index
gen index=0
replace index=1 if sday2>=eday2 & eday2>0
replace eyear2 = 0 if index==1
replace emonth2 = 0 if index==1
replace eday2 = 0 if index==1
drop index

*clean job id  
replace hours1 = 0 if sday1==31 
replace hours2 = 0 if sday2==31
replace job1 = 0 if occ14_1 == 0
replace job1 = 0 if hours1 <= 0
replace job1 = 0 if earn1 <= 0 & rate1<=0
replace job2 = 0 if occ14_2 == 0
replace job2 = 0 if hours2 == 0
replace job2 = 0 if earn2 <= 0 & rate2<=0

*gen multjob
gen index = job1>0
gen index2 = job2>0
gen multjob = index+index2
replace multjob = multjob>1
drop index index2

*generate monthly hours under assumption of smooth 4.3 weeks/month
replace hours1 = 0 if job1<1
replace hours2 = 0 if job2<1
gen weeks_emp = -1
replace weeks_emp = 4.3 if job1>0
replace weeks_emp = (eday1-sday1)/7 if job1>0 & sday1>1 & eday1<28 & eday1>0
replace weeks_emp = (eday1)/7 if job1>0 & eday1<28 & eday1>0 & sday1==0
replace weeks_emp = (31-sday1)/7 if job1>0 & sday1>1 & eday1==0
gen hours1_m = 0
replace hours1_m = weeks_emp*hours1 if job1>0 
drop weeks_emp

gen weeks_emp = -1
replace weeks_emp = 4.3 if job2>0
replace weeks_emp = (eday2-sday2)/7 if job2>0 & sday2>1 & eday2<28 & eday2>0
replace weeks_emp = (eday2)/7 if job2>0 & eday2<28 & eday2>0 & sday2==0
replace weeks_emp = (31-sday2)/7 if job2>0 & sday2>1 & eday2==0
gen hours2_m = 0
replace hours2_m = weeks_emp*hours2 if job2>0 
drop weeks_emp

sort id wave
cd "$rootdir/tmp" 
save test, replace



*compute hourly wages 
gen earn1_h = rate1
replace earn1_h = earn1/hours1_m if job1>0 & earn1_h==0
gen earn2_h = rate2
replace earn2_h = earn2/hours2_m if job2>0 & earn2_h==0
label var earn1_h "Hourly wage"
label var earn2_h "Hourly wage"


*generate potential experience
sort id year month
gen index=0
replace index = year if emp>0 & labor_e_p==.
gen index2 = index
replace index2 = 10000000 if index2==0
by id: egen index3 = min(index2)
replace labor_e_p = index3 if index>0
drop index index2 index3
sort id year month
replace labor_e_p = 100000 if emp==0
by id: egen index = min(labor_e_p)
replace index=0 if index==100000
replace labor_e_p = year-index
replace labor_e_p=0 if labor_e_p==.
replace labor_e_p=0 if labor_e_p<0
replace labor_e_p=0 if index<1900
drop index
label var labor_e_p "Years of potential experience"

*generate experience
replace labor_nw=0 if labor_e_p==0
replace labor_nw = labor_e_p if labor_nw>labor_e_p
sort id year month
gen labor_e = 0
replace labor_e = labor_e_p-labor_nw



*gen main job
sort id year month
gen main_job = job1
replace main_job = job2 if hours1<hours2
by id: gen index_b1 = job1[_n-1]
replace index_b1 = -10 if index_b1==.
by id: gen index_a1 = job1[_n+1]
replace index_a1 = -10 if index_a1==.
by id: gen index_b2 = job2[_n-1]
replace index_b2 = -10 if index_b2==.
by id: gen index_a2 = job2[_n+1]
replace index_a2 = -10 if index_a2==. 
by id: gen emp_b = emp[_n-1]
replace emp_b = -10 if emp_b==.
by id: gen emp_a = emp[_n+1]
replace emp_a = -10 if emp_a==.
gen index = 0
replace index = 1 if multjob==1 & main_job!= index_a1 & main_job!= index_b1 & main_job != index_a2 & main_job != index_b2 & index_a1 !=-10 & index_b1 !=-10 & index_a2 !=-10 & index_b2 !=-10 & emp_a!=0 & emp_b!=0
gen index2 = 0
replace index2 = 1 if index==1 & (job1 == index_a1 | job1 == index_b1 | job2 == index_a2 | job2 == index_b2)
replace main_job = job1 if index2==1 & (job1 == index_a1 | job1 == index_b1)
replace main_job = job2 if index2==1 & (job2 == index_a2 | job2 == index_b2)
drop index index2 index_b1 index_b2 index_a1 index_a2 emp_b emp_a


*summarize main job
label define yesno 1 "Yes" 0 "No"
gen job_id=0
label var job_id "Firm id"
gen job_occ=0
label var job_occ "Occupation"
copydesc occ14_1 job_occ
gen job_ind=0
label var job_ind "Industry"
copydesc ind23_1 job_ind
gen job_hourly = 0
label var job_hourly "Payed by the hour"
label values job_hourly yesno
gen job_earn_h=0
label var job_earn_h "Hourly wages"
gen job_imp=0
label var job_imp "Wage imputed"
label values job_imp yesno
gen job_day_s=0
label var job_day_s "Job day started"
gen job_mo_s=0
label var job_mo_s "Job month started"
gen job_day_e=0
label var job_day_e "Day job ended"
gen job_mo_e=0
label var job_mo_e "Month day started"
gen job_reas_e=0
label var job_reas_e "Reason quitted"
copydesc ersend1 job_reas_e
gen job_union_m=0 
label var job_union_m "Union member"
copydesc union1 job_union_m
gen job_union_c=0 
label var job_union_c "Union contracted"
label values job_union_c yesno
gen job_class=0 
label var job_class "Class of worker"
gen start_y=0
gen start_m=0
gen self =2
label var self "Self employed income"
label define self 1 "Yes" 2 "No"
gen index = 0
replace index=1 if main_job==job1
replace index=2 if main_job==job2
replace job_id = main_job
replace job_occ = occ14_1 if index==1
replace job_occ = occ14_2 if index==2
replace job_ind = ind23_1 if index==1
replace job_ind = ind23_2 if index==2
replace job_hourly = hrly1 if index==1
replace job_hourly = hrly2 if index==2
replace job_earn_h = earn1_h if index==1
replace job_earn_h = earn2_h if index==2
replace job_imp = w_imp1 if index==1
replace job_imp = w_imp2 if index==2
replace job_day_s = sday1 if index==1
replace job_day_s = sday2 if index==2
replace job_mo_s = smonth1 if index==1
replace job_mo_s = smonth2 if index==2
replace job_day_e = eday1 if index==1
replace job_day_e = eday2 if index==2
replace job_mo_e = emonth1 if index==1
replace job_mo_e = emonth2 if index==2
replace job_reas_e = ersend1 if index==1
replace job_reas_e = ersend2 if index==2
replace job_union_m = union1 if index==1
replace job_union_m = union2 if index==2
replace job_union_c = ecntrc1 if index==1
replace job_union_c = ecntrc2 if index==2
replace job_class = class1 if index==1
replace job_class = class2 if index==2
replace start_y = tenure1_s_y if index==1
replace start_y = tenure2_s_y if index==2
replace start_m = tenure1_s_m if index==1
replace start_m = tenure2_s_m if index==2
replace self = selfinc1 if index==1
replace self = selfinc2 if index==2
replace self = self>0
drop index main_job

replace job_ind=0 if job_id==0
replace job_occ=0 if job_id==0
replace job_union_m=0 if job_id==0
replace job_earn_h=0 if job_id==0

*label worker class
replace job_class = 0 if job_class==-1
label define job_class 1 "Private" 2 "Non-profit" 3 "Federal" 4 "StateGov" 5 "LocalGov" 6 "ArmedFor/Unpaid"  

cd "$rootdir/tmp" 
save test, replace


*order job id year month
sort id job_id
egen job_id_new = group(id job_id)
replace job_id_new = 0 if job_id==0
by id: egen index = max(job_id_new)
gen index2 = job_id_new
replace index2 = index if job_id_new==0
by id: egen index3 = min(index2)
replace index3 = index3-1 if index3>0
replace job_id = job_id_new-index3 if job_id>0
drop index index2 index3 job_id_new 
sort id year month


*gen tenure
sort id year month
egen id_job = group(id job_id)
sort id_job year month
by id_job: gen obs = _n
*replace obs = obs-1
gen tenure = 0
replace tenure = (year-start_y)*12+month-start_m if start_y>0 & obs==1
by id_job: replace tenure = tenure[1]+obs
replace tenure=0 if job_id==0
drop id_job obs


gen flag_jobid_chan = 0
rename spanel panel
replace job_earn_h=0 if job_id==0

egen idst = concat(ssuid epppnum)
keep id idst srefmon wave age month year panel flag_jobid_chan rot labor_e_p labor_e esr emp multjob job_id job_occ job_ind job_hourly job_earn_h job_imp job_day_s job_mo_s job_day_e job_mo_e job_class job_reas_e job_union_m job_union_c self tenure rwkesr1 rwkesr2 rwkesr3 rwkesr4 rwkesr5

sort idst year month

label data "Set D: Employment, SIPP1996"
cd "$rootdir/output"
save "/Uni/Het Agents/Daten/SIPP/1996 CEPR/output/set_d.dta", replace
sum
clear
