cd "/Uni/Het Agents/Daten/SIPP/Frictional Wage Dispersion"
use id_panel age month wave wpfinwgt year female metro emp esr job_id job_occ job_ind job_earn_h job_union_m job_union_c job_hourly job_imp job_reas_e tenure time multjob emplyr ephi using final_CEPR, clear

*merge unions
gen job_union = job_union_m+job_union_c
replace job_union = job_union>0 
drop job_union_m job_union_c

*define unemployment/OLF () change response 5 to unemployment
drop if esr ==.
replace emp= 1 if esr == 1 
replace emp= 1 if esr == 2
replace emp= 0 if esr == 6
replace emp= 0 if esr == 7
replace emp= 0 if esr == 8
*replace emp= 0 if esr == 3
*replace emp= 0 if esr == 4
replace emp= 0 if esr == 5
replace emp= 1 if esr == 3
replace emp= 1 if esr == 4
*replace emp= 1 if esr == 5

replace emp = 0 if job_earn_h == 0
egen id = group(id_panel)
drop id_panel
sort id time

drop esr
order id time year month wpfinwgt age female metro emp wave multjob job_id job_occ job_ind job_earn_h job_hourly job_imp job_union job_reas_e tenure ephi emplyr

*used for jtj_statistics.m and jtj_smooth.m
save "/Uni/Het Agents/Daten/SIPP/Frictional Wage Dispersion/flows_final.dta", replace
outsheet using flows_final, comma nolabel nonames replace
clear
