cd "/Uni/Het Agents/Daten/SIPP/Frictional Wage Dispersion"
use id_panel age month wpfinwgt year disabled educ female metro region state rfnkids labor_e esr emp job_id job_occ job_ind job_earn_h job_union_c job_hourly job_imp tenure id_panel time married white race using final_CEPR, clear
egen id = group(id_panel)

keep if emp==1


*keep if job_hourly==1
keep if job_imp==0

replace job_earn_h = log(job_earn_h)

sort id time

reg job_earn_h i.disabled i.female i.married i.race i.rfnkids i.state i.time [pweight=wpfinwgt]
predict yhat
gen resid= job_earn_h-yhat

sort id time

keep id time job_earn_h resid wpfinwgt age 
order id time job_earn_h resid wpfinwgt age 

*used by life-cycle.m
save "/Uni/Het Agents/Daten/SIPP/Frictional Wage Dispersion/life_cycle_final.dta", replace
outsheet using life_cycle_final, comma nolabel nonames replace
clear
