function X = build_X(H)

%build matrix of regression coefficients

%age dummy
[~,~,reorder] = unique(H(:,6));
H(:,6) = reorder;
dummy.age = dummyvar(H(:,6));

%married dummy
[~,~,reorder] = unique(H(:,7));
H(:,7) = reorder;
dummy.married = dummyvar(H(:,7));

%disable dummy
[~,~,reorder] = unique(H(:,8));
H(:,8) = reorder;
dummy.dis = dummyvar(H(:,8));

%educ dummy
[~,~,reorder] = unique(H(:,9));
H(:,9) = reorder;
dummy.educ = dummyvar(H(:,9));

%race dummy
[~,~,reorder] = unique(H(:,10));
H(:,10) = reorder;
dummy.race = dummyvar(H(:,10));

%sex dummy
[~,~,reorder] = unique(H(:,11));
H(:,11) = reorder;
dummy.sex = dummyvar(H(:,11));

%state dummy
[~,~,reorder] = unique(H(:,12));
H(:,12) = reorder;
dummy.state = dummyvar(H(:,12));

%kids dummy
[~,~,reorder] = unique(H(:,13));
H(:,13) = reorder;
dummy.kids = dummyvar(H(:,13));

%occupation dummy
[~,~,reorder] = unique(H(:,14));
H(:,14) = reorder;
dummy.occ = dummyvar(H(:,14));

X = [ones(length(H),1) dummy.age(:,2:end) dummy.married(:,2:end) dummy.dis(:,2:end) dummy.educ(:,2:end) dummy.race(:,2:end) dummy.sex(:,2:end) dummy.state(:,2:end) dummy.kids(:,2:end) dummy.occ(:,2:end)];
%H(:,15) H(:,15).^2
end