clear all
close all
clc

%compute residual wage dispersion over the life-cycle for calibration
%target

%% load data

addpath('Z:\Uni\Het Agents\SIPP\Frictional Wage Dispersion\Data')
M = csvread('life_cycle_final.out');

names = {'ID' 'Time' 'Wage' 'Residual' 'Weight' 'Age'};


%% wage dispersion over the life-cycle

%using cross sectional residuals 
V = M;

age_profile = zeros(max(V(:,6))-min(V(:,6))+1,1);

for i = min(V(:,6)):max(V(:,6))
    age_profile(i-min(V(:,6))+1,1) = var(V(V(:,6)==i,4),V(V(:,6)==i,5)); 
end

var_initial = age_profile(1,1);
var_increase = age_profile(end,1)-age_profile(1,1);
