function g = distribution(wgrid,w_res,destruct,lambda,lambda_d,mu,sigma)

%compute wage distribution

F = logncdf(wgrid,mu,sigma);
F_res = logncdf(w_res,mu,sigma);
F_bar = 1-logncdf(wgrid,mu,sigma);
b = destruct+lambda*lambda_d;
c = lambda*(1-lambda_d);

g = ((F-F_res)./(1-F_res)).*(b./(b+c*F_bar));

end