function w_bar = find_wbar(w_res,wgrid,destruct,lambda,lambda_d,sigma,mu)

%find mean wage

F_res = logncdf(w_res,mu,sigma);
F = logncdf(wgrid,mu,sigma);
a = destruct+lambda;
b = destruct+lambda*lambda_d;
c = lambda*(1-lambda_d); 
factor = (a-c*F_res)./(1-F_res);

int = (1-F)./(b+c*(1-F));
int = trapz(wgrid,int);

w_bar = w_res+factor*int;

end