function f = reservation(w_res,w_max,b,lambda,lambda_u,lambda_d,destruct,r,mu,sigma)

%solves for reservation wage

grid = linspace(w_res,w_max,10000)';   
F_bar = 1-logncdf(grid,mu,sigma);
F_res = logncdf(w_res,mu,sigma);
value = (F_bar)./(destruct+(lambda*lambda_d*F_res)+r+(lambda*lambda_d)+(lambda*(1-lambda_d)*(F_bar)));
int = trapz(grid,value);
f = w_res-b-((lambda_u-lambda)*int);

 
end