function [fenew,funew,mass_offers_headhunt,mass_force_distribute,mass_quitting,prob,wage_gain] = ...
    Dist(fe,fu,nasim,agridsim,fnodes,ProbE1,ProbU,destruct,job_offer,prob_loss,job_prob,breaklevel_1,gamma_w,Prob_Newborn,Prob_firm,job_force,tol_dist,w_dens,death)

%performs distribution function itteration and computes statistics

agridsim_m = repmat(agridsim,1,fnodes); 
critdist = 1;
while critdist > tol_dist
    [fenew,funew,mass_offers_headhunt,mass_force_distribute,mass.before_offers,mass_quitting,prob.eu,prob.ue,prob.move,mass_before_switch,mass_after_switch] =...
        Dist_inner(fe,fu,nasim,agridsim_m,fnodes,ProbE1,ProbU,destruct,job_offer,prob_loss,job_prob,breaklevel_1,gamma_w,Prob_Newborn,Prob_firm,job_force,death);
    
    %Critical Value and Update
    critdist = max(max(max(max(abs(fenew-fe)))),max(max(max(abs(funew-fu)))));
    fe = fenew;
    fu = funew;
end

mass.quitting = sum(sum(mass_quitting))/(sum(sum(sum(fenew))));   %probability of endogenous quitting


w_before_switch = mass_before_switch.*w_dens;
w_after_switch = mass_after_switch.*w_dens;
wage_gain = sum(sum(sum(w_after_switch)))-sum(sum(sum(w_before_switch))); %wage gains from job movement

end
    
