function [y0] = lininter(x,y,x0)

%LININTER y0 = lininter(x,y,x0)
%Function lininter computes a linear interpolation for point x0
%given the vector of x-values in x and their corresponding funtional values
%y

j = sum(x<=x0);
y0 = y(j)+(y(j+1)-y(j))*(x0-x(j))/(x(j+1)-x(j));
end