cd "$rootdir/programs"
do sip93jid
sort suid entry pnum panel wave
rename jobid jobid_old
egen obs = group(suid entry pnum panel wave)
sort obs
gen index = 1
by obs: egen index2 = sum(index)
gen jobid1_old = 0
gen jobid1_rev = 0
gen jobid2_old = 0
gen jobid2_rev = 0
by obs: replace jobid1_old = jobid_old 
by obs: replace jobid1_rev = jobid_revised 
by obs: replace jobid2_old = jobid_old if index2==2
by obs: replace jobid2_rev = jobid_revised if index2==2
drop index2
by obs: replace jobid2_old = jobid2_old[2]
by obs: replace jobid2_rev = jobid2_rev[2]
replace jobid2_old =0 if jobid2_old==.
replace jobid2_rev =0 if jobid2_rev==.
by obs: gen index2=sum(index)
drop if index2==2
drop index index2 jobid_old jobid_revised obs
egen id = concat(suid entry pnum)
sort id panel wave
cd "$rootdir/rawdata"
save sipp1993jid, replace
