*directory
global rootdir /Uni/Het Agents/Daten/SIPP/1996 CEPR

*id consists of ssuid eentaid epppnum
global ids = "id wave srefmon"
global idw = "id wave rot"
global idr = "id rot" 
global f "$rawdata/sipp96l"

*call functions
cd "$rootdir/programs/recode"
do set_a
cd "$rootdir/programs/recode"
do set_b
cd "$rootdir/programs/recode"
do set_d
cd "$rootdir/programs/recode"
do set_h

cd "$rootdir/output"
use set_a, clear
merge idst year month using set_b
tab _merge
rename _merge merge_ab
drop if merge_ab~=3
sort idst year month
merge idst year month using set_d
tab _merge
rename _merge merge_abd
drop if merge_abd~=3
sort idst year month
merge idst year month using set_h
tab _merge
rename _merge merge_abdh
drop if merge_abdh~=3
sort idst year month

egen id_panel = concat(panel id)
drop srefmon id idst merge_* flag*
sort id_panel year month 

label data "SIPP1996"
save "/Uni/Het Agents/Daten/SIPP/1996 CEPR/output/final_1996.dta", replace
clear

